!c Description: 
!c   ʬ黻. 
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2004-08-12    ̰ϯ 
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved


module if_diff_hiacc
  
  interface ss_dx_ss
     function ss_dx1d_ss(var)
       use gridset
       real(8), intent(in) :: var(DimXMin:DimXMax)
       real(8)             :: ss_dx1d_ss(DimXMin:DimXMax)
     end function ss_dx1d_ss
     
     function ss_dx2d_ss(var) 
       use gridset
       real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
       real(8)             :: ss_dx2d_ss(DimXMin:DimXMax, DimZMin:DimZMax)
     end function ss_dx2d_ss
  end interface

  interface ss_dz_ss
     function ss_dz1d_ss(var)
       use gridset
       real(8), intent(in) :: var(DimZMin:DimZMax)
       real(8)             :: ss_dz1d_ss(DimZMin:DimZMax)
     end function ss_dz1d_ss

     function ss_dz2d_ss(var) 
       use gridset
       real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
       real(8)             :: ss_dz2d_ss(DimXMin:DimXMax, DimZMin:DimZMax)
     end function ss_dz2d_ss
  end interface

  interface ss_dx_fs
     function ss_dx1d_fs(var)     
       use gridset
       real(8), intent(in) :: var(DimXMin:DimXMax)
       real(8)             :: ss_dx1d_fs(DimXMin:DimXMax)
     end function ss_dx1d_fs

     function ss_dx2d_fs(var) 
       use gridset
       real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
       real(8)             :: ss_dx2d_fs(DimXMin:DimXMax, DimZMin:DimZMax)
     end function ss_dx2d_fs
  end interface
  
  interface ss_dz_sf
     function ss_dz1d_sf(var)     
       use gridset
       real(8), intent(in) :: var(DimZMin:DimZMax)
       real(8)             :: ss_dz1d_sf(DimZMin:DimZMax)
     end function ss_dz1d_sf
     
     function ss_dz2d_sf(var) 
       use gridset
       real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
       real(8)             :: ss_dz2d_sf(DimXMin:DimXMax, DimZMin:DimZMax)
     end function ss_dz2d_sf
  end interface

  interface ss_dz_fs
     function ss_dz_fs(var) 
       use gridset
       real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
       real(8)             :: ss_dz_fs(DimXMin:DimXMax, DimZMin:DimZMax)
     end function ss_dz_fs
  end interface

  interface ss_dx_sf
     function ss_dx_sf(var) 
       use gridset
       real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
       real(8)             :: ss_dx_sf(DimXMin:DimXMax, DimZMin:DimZMax)
     end function ss_dx_sf
  end interface

  interface fs_dx_ss
     function fs_dx_ss(var) 
       use gridset
       real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
       real(8)             :: fs_dx_ss(DimXMin:DimXMax, DimZMin:DimZMax)
     end function fs_dx_ss
  end interface

  interface fs_dz_ss
     function fs_dz_ss(var) 
       use gridset
       real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
       real(8)             :: fs_dz_ss(DimXMin:DimXMax, DimZMin:DimZMax)
     end function fs_dz_ss
  end interface

  interface fs_dx_fs
     function fs_dx_fs(var)
       use gridset
       real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
       real(8)             :: fs_dx_fs(DimXMin:DimXMax, DimZMin:DimZMax)
     end function fs_dx_fs
  end interface

  interface fs_dz_fs
     function fs_dz_fs(var) 
       use gridset
       real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
       real(8)             :: fs_dz_fs(DimXMin:DimXMax, DimZMin:DimZMax)
     end function fs_dz_fs
  end interface

  interface fs_dx_sf
     function fs_dx_sf(var) 
       use gridset
       real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
       real(8)             :: fs_dx_sf(DimXMin:DimXMax, DimZMin:DimZMax)
     end function fs_dx_sf
  end interface

  interface fs_dz_sf
     function fs_dz_sf(var) 
       use gridset
       real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
       real(8)             :: fs_dz_sf(DimXMin:DimXMax, DimZMin:DimZMax)
     end function fs_dz_sf
  end interface

  interface sf_dx_ss
     function sf_dx_ss(var) 
       use gridset
       real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
       real(8)             :: sf_dx_ss(DimXMin:DimXMax, DimZMin:DimZMax)
     end function sf_dx_ss
  end interface

  interface sf_dz_ss
     function sf_dz_ss(var) 
       use gridset
       real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
       real(8)             :: sf_dz_ss(DimXMin:DimXMax, DimZMin:DimZMax)
     end function sf_dz_ss
  end interface

  interface sf_dx_fs
     function sf_dx_fs(var) 
       use gridset
       real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
       real(8)             :: sf_dx_fs(DimXMin:DimXMax, DimZMin:DimZMax)
     end function sf_dx_fs
  end interface

  interface sf_dz_fs
     function sf_dz_fs(var) 
       use gridset
       real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
       real(8)             :: sf_dz_fs(DimXMin:DimXMax, DimZMin:DimZMax)
     end function sf_dz_fs
  end interface

  interface sf_dx_sf
     function sf_dx_sf(var) 
       use gridset
       real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
       real(8)             :: sf_dx_sf(DimXMin:DimXMax, DimZMin:DimZMax)
     end function sf_dx_sf
  end interface

  interface sf_dz_sf
     function sf_dz_sf(var) 
       use gridset
       real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
       real(8)             :: sf_dz_sf(DimXMin:DimXMax, DimZMin:DimZMax)
     end function sf_dz_sf
  end interface

end module if_diff_hiacc


function ss_dx1d_ss(var)
  use gridset
  implicit none

  real(8), intent(in) :: var(DimXMin:DimXMax)
  real(8)             :: ss_dx1d_ss(DimXMin:DimXMax)
  
  ss_dx1d_ss = 0.0d0
  ss_dx1d_ss(DimXMin+2:DimXMax-2) =       &
       &  (                       &
       &     var(DimXMin+3:DimXMax-1)     &
       &   - var(DimXMin+1:DimXMax-3)     &
       &  ) * 2.0d0 / ( 3.0d0 * DelX )  &
       &- (                             &
       &     var(DimXMin+4:DimXMax)     &
       &   - var(DimXMin:DimXMax+4)     &
       &  ) / ( 12.0d0 * DelX )
end function ss_dx1d_ss


function ss_dz1d_ss(var)
  use gridset
  implicit none
  
  real(8), intent(in) :: var(DimZMin:DimZMax)
  real(8)             :: ss_dz1d_ss(DimZMin:DimZMax)
  
  ss_dz1d_ss = 0.0d0
  ss_dz1d_ss(DimZMin+2:DimZMax-2) =       &
       &  (                       &
       &     var(DimZMin+3:DimZMax-1)     &
       &   - var(DimZMin+3:DimZMax-3)     &
       &  ) * 2.0d0 / ( 3.0d0 * DelX )    &
       &- (                             &
       &     var(DimZMin+4:DimZMax)     &
       &   - var(DimZMin:DimZMax-4)     &
       &  )
end function ss_dz1d_ss


function ss_dx1d_fs(var)     
  use gridset
  implicit none

  real(8), intent(in) :: var(DimXMin:DimXMax)
  real(8)             :: ss_dx1d_fs(DimXMin:DimXMax)
  
  ss_dx1d_fs = 0.0d0
  ss_dx1d_fs(DimXMin+2:DimXMax-1) =       &
       &  (                       &
       &     var(DimXMin+2:DimXMax-1)     &
       &   - var(DimXMin+1:DimXMax-2)     &
       &  ) * 9.0d0 / ( 8.0d0 *DelX )     &
       &- (                             &
       &     var(DimXMin+3:DimXMax)     &
       &   - var(DimXMin:DimXMax-3)    &
       &  ) / (24.0d0 * DelX)
end function ss_dx1d_fs


function ss_dz1d_sf(var)     
  use gridset
  implicit none

  real(8), intent(in) :: var(DimZMin:DimZMax)
  real(8)             :: ss_dz1d_sf(DimZMin:DimZMax)
  
  ss_dz1d_sf = 0.0d0
  ss_dz1d_sf(DimZMin+2:DimZMax-1) =        &
       &  (                       &
       &     var(DimZMin+2:DimZMax-1)     &
       &   - var(DimZMin+1:DimZMax-2)     &
       &  ) * 9.0d0 / ( 8.0d0 * DelZ ) &
       &- (                              &
       &     var(DimZMin+3:DimZMax)    &
       &   - var(DimZMin:DimZMax-3)    &
       &  ) / ( 24.0d0 * DelZ ) 
end function ss_dz1d_sf


function ss_dx2d_ss(var) 
  use gridset
  implicit none

  real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)             :: ss_dx2d_ss(DimXMin:DimXMax, DimZMin:DimZMax)
  
  ss_dx2d_ss = 0.0d0 
  ss_dx2d_ss(DimXMin+2:DimXMax-2,DimZMin:DimZMax) =      &
       &  (                                 &
       &     var(DimXMin+3:DimXMax-1,DimZMin:DimZMax)     &
       &   - var(DimXMin+1:DimXMax-3,DimZMin:DimZMax)     &
       &  ) * 2.0d0 / ( 3.0d0 * DelX )                  &
       &- (                                             &
       &     var(DimXMin+4:DimXMax, DimZMin:DimZMax)   &
       &   - var(DimXMin:DimXMax-4, DimZMin:DimZMax)   &
       &  ) / ( 12.0d0 * DelX )
end function ss_dx2d_ss
  
  
function ss_dz2d_ss(var) 
  use gridset
  implicit none

  real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)             :: ss_dz2d_ss(DimXMin:DimXMax, DimZMin:DimZMax)
  
  ss_dz2d_ss = 0.0d0
  ss_dz2d_ss(DimXMin:DimXMax,DimZMin+2:DimZMax-2) =      &
       &  (                                 &
       &     var(DimXMin:DimXMax,DimZMin+3:DimZMax-1)   &
       &   - var(DimXMin:DimXMax,DimZMin+1:DimZMax-3)   &
       &  ) * 2.0d0 / ( 3.0d0 * DelZ )                &
       &- (                                            &
       &     var(DimXMin:DimXMax,DimZMin+4:DimZMax)   &
       &   - var(DimXMin:DimXMax,DimZMin:DimZMax-4)   &
       &  ) *  ( 12.0d0 * DelZ ) 
end function ss_dz2d_ss


function ss_dx2d_fs(var) 
  use gridset
  implicit none

  real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)             :: ss_dx2d_fs(DimXMin:DimXMax, DimZMin:DimZMax)
  
  ss_dx2d_fs = 0.0d0 
  ss_dx2d_fs(DimXMin+2:DimXMax-1,DimZMin:DimZMax) =       &
       &  (                                 &
       &     var(DimXMin+2:DimXMax-1,DimZMin:DimZMax)     &
       &   - var(DimXMin+1:DimXMax-2,DimZMin:DimZMax)     &
       &  ) * 2.0d0 / ( 3.0d0 * DelX )                    &
       &- (                                               &
       &     var(DimXMin+3:DimXMax,DimZMin:DimZMax)     &
       &   - var(DimXMin:DimXMax-3,DimZMin:DimZMax)     &
       &  ) / ( 24.0d0 * DelX )
end function ss_dx2d_fs


function ss_dz_fs(var) 
  use gridset
  implicit none

  real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)             :: ss_dz_fs(DimXMin:DimXMax, DimZMin:DimZMax)
  
  ss_dz_fs = 0.0d0
  ss_dz_fs(DimXMin+1:DimXMax,DimZMin+2:DimZMax-2) =    &
       &  (                                 &
       &     var(DimXMin+1:DimXMax,DimZMin+3:DimZMax-1)   &
       &   + var(DimXMin:DimXMax-1,DimZMin+3:DimZMax-1)   &
       &   - var(DimXMin+1:DimXMax,DimZMin+1:DimZMax-3)   &
       &   - var(DimXMin:DimXMax-1,DimZMin+1:DimZMax-3)   &
       &  ) / ( 3.0d0 * DelZ )                          &
       &- (                                 &
       &     var(DimXMin+1:DimXMax,DimZMin+4:DimZMax)   &
       &   + var(DimXMin:DimXMax-1,DimZMin+4:DimZMax)   &
       &   - var(DimXMin+1:DimXMax,DimZMin:DimZMax-4)   &
       &   - var(DimXMin:DimXMax-1,DimZMin:DimZMax-4)   &
       &  ) / ( 48.0d0 * DelZ )                    
end function ss_dz_fs
  
  
function ss_dx_sf(var) 
  use gridset
  implicit none
  
  real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)             :: ss_dx_sf(DimXMin:DimXMax, DimZMin:DimZMax)
  
  ss_dx_sf = 0.0d0
  ss_dx_sf(DimXMin+2:DimXMax-2,DimZMin+1:DimZMax) =    &
       &  (                                 &
       &     var(DimXMin+3:DimXMax-1,DimZMin+1:DimZMax)   &
       &   + var(DimXMin+3:DimXMax-1,DimZMin:DimZMax-1)   &
       &   - var(DimXMin+1:DimXMax-3,DimZMin+1:DimZMax)   &
       &   - var(DimXMin+1:DimXMax-3,DimZMin:DimZMax-1)   &
       &  ) / ( 3.0d0 * DelX )              &
       &- (                                 &
       &     var(DimXMin+4:DimXMax,DimZMin+1:DimZMax)   &
       &   + var(DimXMin+4:DimXMax,DimZMin:DimZMax-1)   &
       &   - var(DimXMin:DimXMax-4,DimZMin+1:DimZMax)   &
       &   - var(DimXMin:DimXMax-4,DimZMin:DimZMax-1)   &
       &  ) / ( 48.0d0 * DelX )  
end function ss_dx_sf
  
  
function ss_dz2d_sf(var) 
  use gridset
  implicit none
  
  real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)             :: ss_dz2d_sf(DimXMin:DimXMax, DimZMin:DimZMax)
  
  ss_dz2d_sf = 0.0d0 
  ss_dz2d_sf(DimXMin:DimXMax,DimZMin+2:DimZMax-1) =        &
       &  (                                 &
       &     var(DimXMin:DimXMax,DimZMin+2:DimZMax-1)     &
       &   - var(DimXMin:DimXMax,DimZMin+1:DimZMax-2)     &
       &  ) * 9.0d0 / ( 8.0d0 * DelZ )      &
       &- (                                 &
       &     var(DimXMin:DimXMax,DimZMin+3:DimZMax)       &
       &   - var(DimXMin:DimXMax,DimZMin:DimZMax-3)       &
       &  ) / ( 24.0d0 * DelZ )
end function ss_dz2d_sf



!!!
!!!® u ΰ֤Ǥʬ黻
!!!
function fs_dx_ss(var) 
  use gridset
  implicit none
  
  real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)             :: fs_dx_ss(DimXMin:DimXMax, DimZMin:DimZMax)
  
  fs_dx_ss = 0.0d0
  fs_dx_ss(DimXMin+1:DimXMax-2,DimZMin:DimZMax) =        &
       &  (                                 &
       &     var(DimXMin+2:DimXMax-1,DimZMin:DimZMax)     &
       &   - var(DimXMin+1:DimXMax-2,DimZMin:DimZMax)     &
       &  ) * 9.0d0 / ( 8.0d0 * DelX )      &
       &- (                                 &
       &     var(DimXMin+3:DimXMax,DimZMin:DimZMax)     &
       &   - var(DimXMin:DimXMax-3,DimZMin:DimZMax)     &
       &  ) / ( 24.0d0 * DelX)
end function fs_dx_ss

  
function fs_dz_ss(var) 
  use gridset
  implicit none

  real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)             :: fs_dz_ss(DimXMin:DimXMax, DimZMin:DimZMax)
  
  fs_dz_ss = 0.0d0
  fs_dz_ss(DimXMin:DimXMax-1,DimZMin+2:DimZMax-2) =    &
       &  (                                 &
       &     var(DimXMin+1:DimXMax,DimZMin+3:DimZMax-1)   &
       &   + var(DimXMin:DimXMax-1,DimZMin+3:DimZMax-1)   &
       &   - var(DimXMin+1:DimXMax,DimZMin+1:DimZMax-3)   &
       &   - var(DimXMin:DimXMax-1,DimZMin+1:DimZMax-3)   &
       &  ) / ( 3.0d0 * DelZ )              &
       &- (                                 &
       &     var(DimXMin+1:DimXMax,DimZMin+4:DimZMax)   &
       &   + var(DimXMin:DimXMax-1,DimZMin+4:DimZMax)   &
       &   - var(DimXMin+1:DimXMax,DimZMin:DimZMax-4)   &
       &   - var(DimXMin:DimXMax-1,DimZMin:DimZMax-4)   &
       &  ) / ( 48.0d0 * DelZ )
end function fs_dz_ss
  
  
function fs_dx_fs(var)
  use gridset
  implicit none

  real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)             :: fs_dx_fs(DimXMin:DimXMax, DimZMin:DimZMax)
  
  fs_dx_fs = 0.0d0 
  fs_dx_fs(DimXMin+2:DimXMax-2,DimZMin:DimZMax) =      &
       &  (                                 &
       &     var(DimXMin+3:DimXMax-1,DimZMin:DimZMax)     &
       &   - var(DimXMin+1:DimXMax-3,DimZMin:DimZMax)     &
       &  ) * 2.0d0 / ( 3.0d0 * DelX )      &
       &- (                                 &
       &     var(DimXMin+4:DimXMax,DimZMin:DimZMax)     &
       &   - var(DimXMin:DimXMax-4,DimZMin:DimZMax)     &
       &  ) / ( 12.0d0 * DelX ) 
end function fs_dx_fs

  
function fs_dz_fs(var) 
  use gridset
  implicit none
  
  real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)             :: fs_dz_fs(DimXMin:DimXMax, DimZMin:DimZMax)
  
  fs_dz_fs = 0.0d0 
  fs_dz_fs(DimXMin:DimXMax,DimZMin+2:DimZMax-2) =      &
       &  (                                 &
       &     var(DimXMin:DimXMax,DimZMin+3:DimZMax-1)     &
       &   - var(DimXMin:DimXMax,DimZMin+1:DimZMax-3)     &
       &  ) * 2.0d0 / ( 3.0d0 * DelZ )                  &
       &- (                                 &
       &     var(DimXMin:DimXMax,DimZMin+4:DimZMax)     &
       &   - var(DimXMin:DimXMax,DimZMin:DimZMax-4)     &
       &  ) / ( 12.0d0 * DelZ )
end function fs_dz_fs

   
function fs_dx_sf(var) 
  use gridset
  implicit none

  real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)             :: fs_dx_sf(DimXMin:DimXMax, DimZMin:DimZMax)
  
  fs_dx_sf = 0.0d0
  fs_dx_sf(DimXMin+1:DimXMax-2,DimZMin+1:DimZMax) =    &
       &  (                                 &
       &     var(DimXMin+2:DimXMax-1,DimZMin+1:DimZMax)   &
       &   + var(DimXMin+2:DimXMax-1,DimZMin:DimZMax-1)   &
       &   - var(DimXMin+1:DimXMax-2,DimZMin+1:DimZMax)   &
       &   - var(DimXMin+1:DimXMax-2,DimZMin:DimZMax-1)   &
       &  ) * 9.0d0 / ( 16.0d0 * DelX )     &
       &- (                                 &
       &     var(DimXMin+3:DimXMax,DimZMin+1:DimZMax)   &
       &   + var(DimXMin+3:DimXMax,DimZMin:DimZMax-1)   &
       &   - var(DimXMin:DimXMax-3,DimZMin+1:DimZMax)   &
       &   - var(DimXMin:DimXMax-3,DimZMin:DimZMax-1)   &
       &  ) / ( 48.0d0 * DelX )
end function fs_dx_sf
  
  
function fs_dz_sf(var) 
  use gridset
  implicit none

  real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)             :: fs_dz_sf(DimXMin:DimXMax, DimZMin:DimZMax)
  
  fs_dz_sf = 0.0d0
  fs_dz_sf(DimXMin+1:DimXMax,DimZMin+1:DimZMax-2) =      &
       &  (                                 &
       &     var(DimXMin+1:DimXMax,DimZMin+2:DimZMax-1)   &
       &   + var(DimXMin:DimXMax-1,DimZMin+2:DimZMax-1)   &
       &   - var(DimXMin+1:DimXMax,DimZMin+1:DimZMax-2)   &
       &   - var(DimXMin:DimXMax-1,DimZMin+1:DimZMax-2)   &
       &  ) * 9.0d0 / ( 16.0d0 * DelZ )     &
       &- (                                 &
       &     var(DimXMin+1:DimXMax,DimZMin+3:DimZMax)   &
       &   + var(DimXMin:DimXMax-1,DimZMin+3:DimZMax)   &
       &   - var(DimXMin+1:DimXMax,DimZMin:DimZMax-3)   &
       &   - var(DimXMin:DimXMax-1,DimZMin:DimZMax-3)   &
       &  ) / ( 48.0d0 * DelZ )    
end function fs_dz_sf


!!!
!!!® w ΰ֤Ǥʬ
!!!
function sf_dx_ss(var) 
  use gridset
  implicit none
  
  real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)             :: sf_dx_ss(DimXMin:DimXMax, DimZMin:DimZMax)
  
  sf_dx_ss = 0.0d0 
  sf_dx_ss(DimXMin+2:DimXMax-2,DimZMin:DimZMax-1) =    &
       &  (                                 &
       &     var(DimXMin+3:DimXMax-1,DimZMin+1:DimZMax)   &
       &   + var(DimXMin+3:DimXMax-1,DimZMin:DimZMax-1)   &
       &   - var(DimXMin+1:DimXMax-3,DimZMin+1:DimZMax)   &
       &   - var(DimXMin+1:DimXMax-3,DimZMin:DimZMax-1)   &
       &  ) / ( 3.0d0 * DelX )              &
       &- (                                 &
       &     var(DimXMin+4:DimXMax,DimZMin+1:DimZMax)   &
       &   + var(DimXMin+4:DimXMax,DimZMin:DimZMax-1)   &
       &   - var(DimXMin:DimXMax-4,DimZMin+1:DimZMax)   &
       &   - var(DimXMin:DimXMax-4,DimZMin:DimZMax-1)   &
       &  ) / ( 24.0d0 * DelX ) 
end function sf_dx_ss
  
  
function sf_dz_ss(var) 
  use gridset
  implicit none

  real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)             :: sf_dz_ss(DimXMin:DimXMax, DimZMin:DimZMax)

  sf_dz_ss = 0.0d0 
  sf_dz_ss(DimXMin:DimXMax,DimZMin+1:DimZMax-2) =        &
       &  (                                 &
       &     var(DimXMin:DimXMax,DimZMin+2:DimZMax-1)     &
       &   - var(DimXMin:DimXMax,DimZMin+1:DimZMax-2)     &
       &  ) * 9.0d0 / ( 8.0d0 * DelZ )      &
       &- (                                 &
       &     var(DimXMin:DimXMax,DimZMin+3:DimZMax)     &
       &   - var(DimXMin:DimXMax,DimZMin:DimZMax-3)     &
       &  ) / ( 24.0d0 * DelZ )
end function sf_dz_ss

  
function sf_dx_fs(var) 
  use gridset
  implicit none

  real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)             :: sf_dx_fs(DimXMin:DimXMax, DimZMin:DimZMax)

  sf_dx_fs = 0.0d0 
  sf_dx_fs(DimXMin+2:DimXMax-1,DimZMin:DimZMax-1) =    &
       &  (                                 &
       &     var(DimXMin+2:DimXMax-1,DimZMin+1:DimZMax)   &
       &   + var(DimXMin+2:DimXMax-1,DimZMin:DimZMax-1)   &
       &   - var(DimXMin+1:DimXMax-2,DimZMin+1:DimZMax)   &
       &   - var(DimXMin+1:DimXMax-2,DimZMin:DimZMax-1)   &
       &  ) * 9.0d0 / ( 16.0d0 * DelX )     &
       &- (                                 &
       &     var(DimXMin+3:DimXMax,DimZMin+1:DimZMax)   &
       &   + var(DimXMin+3:DimXMax,DimZMin:DimZMax-1)   &
       &   - var(DimXMin:DimXMax-3,DimZMin+1:DimZMax)   &
       &   - var(DimXMin:DimXMax-3,DimZMin:DimZMax-1)   &
       &  ) / ( 48.0d0 * DelX )

end function sf_dx_fs


function sf_dz_fs(var) 
  use gridset
  implicit none

  real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)             :: sf_dz_fs(DimXMin:DimXMax, DimZMin:DimZMax)
  
  sf_dz_fs = 0.0d0 
  sf_dz_fs(DimXMin+1:DimXMax,DimZMin+1:DimZMax-2) =      &
       &  (                                 &
       &     var(DimXMin+1:DimXMax,DimZMin+2:DimZMax-1)   &
       &   + var(DimXMin:DimXMax-1,DimZMin+2:DimZMax-1)   &
       &   - var(DimXMin+1:DimXMax,DimZMin+1:DimZMax-2)   &
       &   - var(DimXMin:DimXMax-1,DimZMin+1:DimZMax-2)   &
       &  ) * 9.0d0  / ( 16.0d0 * DelZ )     &
       &- (                                  &
       &     var(DimXMin+1:DimXMax,DimZMin+3:DimZMax)   &
       &   + var(DimXMin:DimXMax-1,DimZMin+3:DimZMax)   &
       &   - var(DimXMin+1:DimXMax,DimZMin:DimZMax-3)   &
       &   - var(DimXMin:DimXMax-1,DimZMin:DimZMax-3)   &
       &  ) * 9.0d0  / ( 16.0d0 * DelZ )    
end function sf_dz_fs
  
  
function sf_dx_sf(var) 
  use gridset
  implicit none

  real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)             :: sf_dx_sf(DimXMin:DimXMax, DimZMin:DimZMax)
 
  sf_dx_sf = 0.0d0 
  sf_dx_sf(DimXMin+2:DimXMax-2,DimZMin:DimZMax) =      & 
       &  (                                 &
       &     var(DimXMin+3:DimXMax-1,DimZMin:DimZMax)     &
       &   - var(DimXMin+1:DimXMax-3,DimZMin:DimZMax)     &
       &  ) * 2.0d0 / ( 3.0d0 * DelX )      &
       &- (                                 &
       &     var(DimXMin+4:DimXMax,DimZMin:DimZMax)     &
       &   - var(DimXMin:DimXMax-4,DimZMin:DimZMax)     &
       &  ) / ( 12.0d0 * DelX ) 
end function sf_dx_sf
  
  
function sf_dz_sf(var) 
  use gridset
  implicit none

  real(8), intent(in) :: var(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)             :: sf_dz_sf(DimXMin:DimXMax, DimZMin:DimZMax)
  
  sf_dz_sf = 0.0d0 
  sf_dz_sf(DimXMin:DimXMax,DimZMin+2:DimZMax-2) =      &
       &  (                                 &
       &     var(DimXMin:DimXMax,DimZMin+3:DimZMax-1)     &
       &   - var(DimXMin:DimXMax,DimZMin+1:DimZMax-3)     &
       &  ) * 2.0d0 / ( 3.0d0 * DelZ )      &
       &- (                                 &
       &     var(DimXMin:DimXMax,DimZMin+4:DimZMax)     &
       &   - var(DimXMin:DimXMax,DimZMin:DimZMax-4)     &
       &  ) / ( 12.0d0 * DelZ )  
end function sf_dz_sf
